"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var figlet_1 = __importDefault(require("figlet"));
var minimist_1 = __importDefault(require("minimist"));
var semver_1 = __importDefault(require("semver"));
var strip_json_comments_1 = __importDefault(require("strip-json-comments"));
var constant_1 = require("../shared/constant");
var file_1 = require("../shared/file");
var core_1 = __importDefault(require("../core"));
var pkg = JSON.parse((0, strip_json_comments_1.default)(fs_1.default.readFileSync(path_1.default.resolve(__dirname, '../../package.json'), 'utf8').replace(/^\ufeff/u, '')));
function entry() {
    return __awaiter(this, void 0, void 0, function () {
        var args, stats, feflow, commander, logger, reporter, fefError, handleUnexpectedError, cmdName, localCmd;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    args = (0, minimist_1.default)(process.argv.slice(2), {
                        alias: {
                            h: 'help',
                            v: 'version',
                        },
                    });
                    // 检查node版本
                    ensureNodeVersion(pkg.engines.node, pkg.name);
                    try {
                        stats = fs_1.default.statSync(constant_1.FEFLOW_HOME);
                        if (!stats.isDirectory()) {
                            fs_1.default.unlinkSync(constant_1.FEFLOW_HOME);
                        }
                    }
                    catch (e) {
                        fs_1.default.mkdirSync(constant_1.FEFLOW_HOME);
                    }
                    // 确保日志相关本地文件存在，避免报错
                    (0, file_1.fileExit)(path_1.default.join(constant_1.FEFLOW_HOME, constant_1.HEART_BEAT_COLLECTION_LOG));
                    (0, file_1.fileExit)(path_1.default.join(constant_1.FEFLOW_HOME, constant_1.LOG_FILE));
                    feflow = new core_1.default(args);
                    commander = feflow.commander, logger = feflow.logger, reporter = feflow.reporter, fefError = feflow.fefError;
                    handleUnexpectedError = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        var _a = __read(args, 1), err = _a[0];
                        logger.error(err);
                        reporter.reportCommandError(err);
                        fefError.printError({ error: err, msg: '', hideError: true });
                    };
                    // 捕获promise异常退出或catch中抛出异常
                    process.on('unhandledRejection', handleUnexpectedError);
                    // 捕获未被 catch 的异常
                    process.on('uncaughtException', handleUnexpectedError);
                    cmdName = args._.shift();
                    if (!cmdName && args.version) {
                        reporter.report('version', args);
                        logger.info(pkg.version);
                        return [2 /*return*/];
                    }
                    if (!cmdName && !args.help) {
                        printBanner(logger);
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, feflow.init(cmdName)];
                case 1:
                    _a.sent();
                    localCmd = commander.get(cmdName);
                    // 本地无法找到命令执行文件获取失败时转为help命令
                    if (!localCmd) {
                        cmdName && logger.debug("Can't found command: ".concat(cmdName));
                        cmdName = 'help';
                    }
                    feflow.cmd = cmdName;
                    feflow.hook.emit(constant_1.HOOK_TYPE_BEFORE);
                    feflow.hook.on(constant_1.EVENT_COMMAND_BEGIN, function () { return __awaiter(_this, void 0, void 0, function () {
                        var err_1;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    return [4 /*yield*/, feflow.invoke(cmdName, feflow)];
                                case 1:
                                    _a.sent();
                                    feflow.hook.emit(constant_1.HOOK_TYPE_AFTER);
                                    logger.debug("call ".concat(cmdName, " success"));
                                    return [3 /*break*/, 3];
                                case 2:
                                    err_1 = _a.sent();
                                    logger.error(err_1);
                                    reporter.reportCommandError(err_1);
                                    fefError.printError({
                                        error: err_1,
                                        msg: '%s',
                                    });
                                    process.exit(2);
                                    return [3 /*break*/, 3];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    return [2 /*return*/];
            }
        });
    });
}
exports.default = entry;
function ensureNodeVersion(requiredVersion, id) {
    if (!semver_1.default.satisfies(process.version, requiredVersion)) {
        console.error("You are using Node ".concat(process.version, ", but this version of ").concat(id, " requires Node ").concat(requiredVersion, ".\nPlease upgrade your Node version."));
        process.exit(1);
    }
}
function printBanner(logger) {
    figlet_1.default.text('feflow', {
        font: '3D-ASCII',
        horizontalLayout: 'default',
        verticalLayout: 'default',
    }, function (err, data) {
        if (err) {
            logger.error(err);
            process.exit(2);
        }
        logger.info("\n".concat(data));
        logger.info("Feflow\uFF0Ccurrent version: v".concat(pkg.version, ", homepage: https://github.com/Tencent/feflow"));
        logger.info('(c) powered by Tencent, aims to improve front end workflow.');
        logger.info('Run fef --help to see usage.');
    });
}
//# sourceMappingURL=index.js.map