"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var getCommandLine = function (optionsDescription, description, cmd) {
    if (Array.isArray(optionsDescription))
        return optionsDescription;
    var options = [];
    var optionDescriptions = Object.keys(optionsDescription);
    if (!optionDescriptions.length)
        return options;
    optionDescriptions.forEach(function (option) {
        var optionItemConfig = optionsDescription[option];
        var optionDescriptionItem = getOptionItem(optionItemConfig, option);
        options.push(optionDescriptionItem);
    });
    return [
        {
            header: "fef ".concat(cmd),
            content: description,
        },
        {
            header: 'Usage',
            content: "$ fef ".concat(cmd, " [options]"),
        },
        {
            header: 'Options',
            optionList: options,
        },
    ];
};
var getOptionItem = function (optionItemConfig, option) {
    var optionItemConfigCopy;
    if (typeof optionItemConfig === 'string') {
        optionItemConfigCopy = {
            name: option,
            description: optionItemConfig,
        };
    }
    else {
        optionItemConfigCopy = __assign({}, optionItemConfig);
        if (!optionItemConfigCopy.name) {
            optionItemConfigCopy.name = option;
        }
        optionItemConfigCopy.type = typeof optionItemConfig.type === 'function' ? optionItemConfig.type : String;
    }
    return optionItemConfigCopy;
};
exports.default = getCommandLine;
//# sourceMappingURL=command-options.js.map