"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var config_1 = __importDefault(require("./config"));
var command_options_1 = __importDefault(require("./command-options"));
var logger_1 = __importDefault(require("../logger"));
var constant_1 = require("../../shared/constant");
var registerDevkitCommand = function (command, commandConfig, directoryPath, ctx) {
    var builder = commandConfig.builder, builderOptions = commandConfig.options;
    var _a = __read(builder.split(':', 2), 2), packageName = _a[0], devkitCmd = _a[1];
    var config = new config_1.default(ctx);
    var pkgPath = path_1.default.join(directoryPath, 'node_modules', packageName);
    try {
        var devkitConfig = config.loadDevkitConfig(pkgPath);
        if (!devkitConfig) {
            ctx.logger.debug('devkit config not found!');
            return;
        }
        var _b = devkitConfig.builders[devkitCmd], implementation_1 = _b.implementation, description = _b.description, optionsDescription = _b.optionsDescription, _c = _b.usage, usage = _c === void 0 ? {} : _c;
        var options = (0, command_options_1.default)(optionsDescription || usage, description, command);
        var devkitLogger_1 = (0, logger_1.default)({
            debug: Boolean(ctx.args.debug),
            silent: Boolean(ctx.args.silent),
            name: packageName,
        });
        if (Array.isArray(implementation_1)) {
            ctx.commander.register(command, description, function () { return __awaiter(void 0, void 0, void 0, function () {
                var implementation_2, implementation_2_1, implementationItem, action, devkitCommandEntry, e_1_1;
                var e_1, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 5, 6, 7]);
                            implementation_2 = __values(implementation_1), implementation_2_1 = implementation_2.next();
                            _b.label = 1;
                        case 1:
                            if (!!implementation_2_1.done) return [3 /*break*/, 4];
                            implementationItem = implementation_2_1.value;
                            action = path_1.default.join(pkgPath, implementationItem);
                            return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require(action)); })];
                        case 2:
                            devkitCommandEntry = _b.sent();
                            devkitCommandEntry.default(Object.assign({}, ctx, { logger: devkitLogger_1, options: builderOptions }));
                            _b.label = 3;
                        case 3:
                            implementation_2_1 = implementation_2.next();
                            return [3 /*break*/, 1];
                        case 4: return [3 /*break*/, 7];
                        case 5:
                            e_1_1 = _b.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 7];
                        case 6:
                            try {
                                if (implementation_2_1 && !implementation_2_1.done && (_a = implementation_2.return)) _a.call(implementation_2);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 7: return [2 /*return*/];
                    }
                });
            }); }, options, packageName);
        }
        else {
            var action_1 = path_1.default.join(pkgPath, implementation_1);
            ctx.commander.register(command, description, function () { return __awaiter(void 0, void 0, void 0, function () {
                var devkitCommandEntry;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require(action_1)); })];
                        case 1:
                            devkitCommandEntry = _a.sent();
                            devkitCommandEntry.default(Object.assign({}, ctx, { logger: devkitLogger_1, options: builderOptions }));
                            return [2 /*return*/];
                    }
                });
            }); }, options, packageName);
        }
    }
    catch (e) {
        ctx.logger.debug(e, 'register devkit command failed');
    }
};
function loadDevkits(ctx) {
    var _a;
    var config = new config_1.default(ctx);
    var configData = config.loadProjectConfig();
    var directoryPath = config.getProjectDirectory();
    if (configData) {
        ctx.projectPath = directoryPath;
        ctx.projectConfig = configData;
        if ((_a = configData.devkit) === null || _a === void 0 ? void 0 : _a.commands) {
            var commandsConfig = configData.devkit.commands;
            Object.entries(commandsConfig).forEach(function (_a) {
                var _b = __read(_a, 2), key = _b[0], commandConfig = _b[1];
                registerDevkitCommand(key, commandConfig, directoryPath, ctx);
            });
        }
        else {
            if (path_1.default.basename(directoryPath) === constant_1.FEFLOW_ROOT) {
                ctx.logger.debug('Run commands in .fef root will not work.');
            }
            else {
                ctx.logger.error("A config file .feflowrc(.js|.yaml|.yml|.json) was detected in ".concat(directoryPath, ", but lost required property 'commands' in field 'devkit'. Please check your config file or just delete it."));
            }
        }
    }
    else {
        ctx.logger.debug('Run commands not in a feflow project.');
    }
}
exports.default = loadDevkits;
//# sourceMappingURL=load-devkits.js.map