import Report from '@feflow/report';
import minimist from 'minimist';
import Commander from './commander';
import Hook from './hook';
import { Logger } from './logger';
import CommandPicker from './command-picker';
import { UniversalPkg } from './universal-pkg/dep/pkg';
import { FefError } from '../shared/fef-error';
import { FeflowConfig } from '../shared/type-predicates';
export default class Feflow {
    args: minimist.ParsedArgs;
    root: string;
    rootPkg: string;
    configPath: string;
    bin: string;
    lib: string;
    loggerPath: string;
    universalPkgPath: string;
    universalModules: string;
    version: string;
    logger: Logger;
    commander: Commander;
    hook: Hook;
    config?: Partial<FeflowConfig>;
    universalPkg: UniversalPkg;
    reporter: Report;
    commandPick: CommandPicker | null;
    fefError: FefError;
    cmd?: string;
    projectPath?: string;
    projectConfig?: object;
    pkgConfig?: {
        name: string;
    };
    constructor(args: minimist.ParsedArgs);
    init(cmdName?: string): Promise<void>;
    initClient(): Promise<void>;
    initBinPath(): Promise<void>;
    initPackageManager(): Promise<void>;
    loadNative(): void;
    loadCommands(orderType: number): Promise<void>;
    loadInternalPlugins(): Promise<any>;
    invoke(cmdName: string | undefined, ctx: Feflow): Promise<void>;
    showCommandOptionDescription(cmdName: string, ctx: Feflow): Promise<any>;
}
//# sourceMappingURL=index.d.ts.map