"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var bunyan_1 = __importDefault(require("bunyan"));
var stream_1 = require("stream");
var path_1 = __importDefault(require("path"));
var osenv_1 = __importDefault(require("osenv"));
var child_process_1 = require("child_process");
var chalk_1 = __importDefault(require("chalk"));
var constant_1 = require("../../shared/constant");
var file_1 = require("../../shared/file");
var package_json_1 = __importDefault(require("../../../package.json"));
var root = path_1.default.join(osenv_1.default.home(), constant_1.FEFLOW_ROOT);
var heartDBFile = path_1.default.join(root, constant_1.HEART_BEAT_COLLECTION_LOG);
var logReportProcess = null;
var reportLog = path_1.default.join(__dirname, './report');
var hasCreateHeart = false;
var logReportDbKey = 'log_report_beat_time';
var _a = process.env, debug = _a.debug, silent = _a.silent;
function createLogger(options) {
    var streams = [];
    streams.push({
        level: 'error',
        path: path_1.default.join(root, constant_1.LOG_FILE),
    });
    streams.push({
        level: 'info',
        path: path_1.default.join(root, constant_1.LOG_FILE),
    });
    if (!options.silent) {
        streams.push({
            type: 'raw',
            level: options.debug ? 'trace' : 'info',
            stream: new ConsoleStream(options),
        });
    }
    if (options.debug) {
        streams.push({
            level: 'trace',
            path: path_1.default.join(root, 'debug.log'),
        });
    }
    return bunyan_1.default.createLogger({
        name: options.name || 'feflow-cli',
        streams: streams,
        serializers: {
            err: bunyan_1.default.stdSerializers.err,
        },
    });
}
exports.default = createLogger;
var levelNames = {
    10: 'Trace',
    20: 'Debug',
    30: 'Info',
    40: 'Warn',
    50: 'Error',
    60: 'Fatal',
};
var levelColors = {
    10: 'gray',
    20: 'gray',
    30: 'green',
    40: 'orange',
    50: 'red',
    60: 'red',
};
var ConsoleStream = /** @class */ (function (_super) {
    __extends(ConsoleStream, _super);
    function ConsoleStream(args) {
        var _this = _super.call(this, {
            objectMode: true,
        }) || this;
        _this.debug = Boolean(args.debug);
        return _this;
    }
    // 上报
    ConsoleStream.prototype.startReport = function () {
        var report = function () {
            // 子进程执行日志上报
            logReportProcess = (0, child_process_1.spawn)(process.argv[0], [reportLog], {
                detached: true,
                stdio: 'ignore',
                env: __assign(__assign({}, process.env), { // env 无法把 ctx 传进去，会自动 string 化
                    debug: debug, silent: silent }),
                windowsHide: true,
            });
            // 父进程不会等待子进程
            logReportProcess.unref();
        };
        var cacheValidate = false;
        var nowTime = new Date().getTime();
        var lastBeatTime = (0, file_1.getKeyFormFile)(heartDBFile, logReportDbKey);
        if (lastBeatTime) {
            // 在一次心跳时间内只允许创建一次子进程
            cacheValidate = nowTime - lastBeatTime <= constant_1.LOG_REPORT_BEAT_GAP;
            // 防止瞬时大量数据，导致lastBeatTime还未更新时触发多次子进程创建
            if (!cacheValidate && !hasCreateHeart) {
                hasCreateHeart = true;
                (0, file_1.setKeyToFile)(heartDBFile, logReportDbKey, String(nowTime));
                hasCreateHeart = false;
                report();
            }
        }
        else if (!hasCreateHeart) {
            hasCreateHeart = true;
            (0, file_1.setKeyToFile)(heartDBFile, logReportDbKey, String(nowTime));
            hasCreateHeart = false;
            report();
        }
    };
    // 此方法必须保留，因为继承一个 writable stream 时必须重写其 _write 方法
    // eslint-disable-next-line @typescript-eslint/naming-convention
    ConsoleStream.prototype._write = function (data, encoding, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var level, PLUGIN_NAME, loggerName, msg, err;
            return __generator(this, function (_a) {
                level = data.level;
                PLUGIN_NAME = "feflow-".concat(package_json_1.default.name.split('/').pop());
                loggerName = data.name || PLUGIN_NAME;
                msg = '';
                if (this.debug) {
                    msg += "".concat(chalk_1.default.gray(data.time), " ");
                }
                msg += chalk_1.default.keyword(levelColors[level])("[ Feflow ".concat(levelNames[level], " ]"));
                msg += "[ ".concat(loggerName, " ] ");
                msg += "".concat(data.msg, "\n");
                if (data.err) {
                    err = data.err.stack || data.err.message;
                    if (err)
                        msg += "".concat(chalk_1.default.yellow(err), "\n");
                }
                Object.assign(data, {
                    level: level,
                    msg: "[Feflow ".concat(levelNames[level], "][").concat(loggerName, "]").concat(data.msg),
                    date: new Date().getTime(),
                    name: loggerName,
                });
                if (level >= 40) {
                    process.stderr.write(msg);
                }
                else {
                    process.stdout.write(msg);
                }
                this.startReport();
                callback();
                return [2 /*return*/];
            });
        });
    };
    return ConsoleStream;
}(stream_1.Writable));
//# sourceMappingURL=index.js.map