"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.timer = void 0;
var osenv_1 = __importDefault(require("osenv"));
var fs_1 = __importDefault(require("fs"));
var axios_1 = __importDefault(require("axios"));
var path_1 = __importDefault(require("path"));
var os_1 = __importDefault(require("os"));
var constant_1 = require("../../shared/constant");
var package_json_1 = __importDefault(require("../../../package.json"));
var LOGGER_LOG_PATH = path_1.default.join(osenv_1.default.home(), constant_1.FEFLOW_ROOT, constant_1.LOG_FILE);
var KEYS_FILE = path_1.default.join(__dirname, '../../../.keys');
var USER_NAME = os_1.default.hostname().split('-')[0];
var NOW_TIME = new Date().getTime();
var PLUGE_NAME = "feflow-".concat(package_json_1.default.name.split('/').pop());
var hasTimer = process.env.hasTimer;
var keysFileContent = {};
(function () { return __awaiter(void 0, void 0, void 0, function () {
    var result;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                try {
                    keysFileContent = JSON.parse(fs_1.default.readFileSync(KEYS_FILE, 'utf-8'));
                }
                catch (err) { }
                if (!(!keysFileContent.time || NOW_TIME - keysFileContent.time > 5184e6)) return [3 /*break*/, 2];
                return [4 /*yield*/, axios_1.default.get("http://log.feflowjs.com/api/v1/summary/getskey?rtx=".concat(USER_NAME))];
            case 1:
                result = (_a.sent()).data.result;
                keysFileContent = {
                    time: NOW_TIME,
                    skey: result.skey,
                };
                fs_1.default.writeFileSync(KEYS_FILE, JSON.stringify(keysFileContent), 'utf-8');
                _a.label = 2;
            case 2: return [2 /*return*/];
        }
    });
}); })();
var levelNames = {
    10: 'Trace',
    20: 'Debug',
    30: 'Info',
    40: 'Warn',
    50: 'Error',
    60: 'Fatal',
};
// eslint-disable-next-line import/no-mutable-exports
exports.timer = null;
function send(logObj, readData) {
    return __awaiter(this, void 0, void 0, function () {
        var loggerList, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    loggerList = readData
                        .filter(function (data) { return data; })
                        .map(function (data) {
                        var logger = JSON.parse(data);
                        var level = logger.level;
                        var loggerName = logger.name || (logObj === null || logObj === void 0 ? void 0 : logObj.name.split('/').pop()) || PLUGE_NAME;
                        return {
                            level: level,
                            msg: "[Feflow ".concat(levelNames[level], "][").concat(loggerName, "]").concat(logger.msg),
                            date: new Date().getTime(),
                            name: loggerName,
                        };
                    });
                    // 清除数据
                    fs_1.default.writeFile(LOGGER_LOG_PATH, '', 'utf8', function () { });
                    return [4 /*yield*/, axios_1.default.post('http://log.feflowjs.com/api/v1/log/save', {
                            plugin: loggerList[0].name,
                            data: JSON.stringify(loggerList),
                        }, {
                            headers: {
                                skey: keysFileContent.skey,
                                rtx: USER_NAME,
                            },
                        })];
                case 1:
                    response = _a.sent();
                    if (response.status === 204) {
                        console.log('send success');
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function report(logObj) {
    return __awaiter(this, void 0, void 0, function () {
        var readStr, readData_1;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    readStr = fs_1.default.readFileSync(LOGGER_LOG_PATH, 'utf-8');
                    if (!readStr) return [3 /*break*/, 2];
                    readData_1 = readStr.split('\n');
                    // 数量太少暂时不上报
                    if (readData_1.length < 20) {
                        // 如果有timer则不创新新的timer
                        if (!hasTimer) {
                            exports.timer = setTimeout(function () {
                                (function () { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, send(logObj, readData_1)];
                                            case 1:
                                                _a.sent();
                                                exports.timer && clearTimeout(exports.timer);
                                                exports.timer = null;
                                                return [2 /*return*/];
                                        }
                                    });
                                }); })();
                            }, 5000);
                        }
                        return [2 /*return*/];
                    }
                    exports.timer && clearTimeout(exports.timer);
                    exports.timer = null;
                    return [4 /*yield*/, send(logObj, readData_1)];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
}
report();
//# sourceMappingURL=report.js.map