"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var inquirer_1 = __importDefault(require("inquirer"));
var yeoman_environment_1 = __importDefault(require("yeoman-environment"));
var npm_1 = require("../../shared/npm");
exports.default = (function (ctx) {
    ctx.commander.register('init', 'Create a new project', function () { return __awaiter(void 0, void 0, void 0, function () {
        var root, rootPkg, args, generator, generators, isGeneratorInstalled, askIfInstallGenerator, answer, packageManager, options, answer_1, _a, name_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    root = ctx.root, rootPkg = ctx.rootPkg, args = ctx.args;
                    generator = args.generator;
                    return [4 /*yield*/, loadGenerator(root, rootPkg)];
                case 1:
                    generators = _b.sent();
                    if (!(generator && /^generator-|^@[^/]+\/generator-/.test(generator))) return [3 /*break*/, 4];
                    isGeneratorInstalled = generators.some(function (item) { return item.name === generator; });
                    if (isGeneratorInstalled) {
                        return [2 /*return*/, run(ctx, generator)];
                    }
                    askIfInstallGenerator = [
                        {
                            type: 'confirm',
                            name: 'ifInstall',
                            message: "You have not installed the generator ".concat(generator, "\uFF0Cif you want to install and use ?"),
                            default: true,
                        },
                    ];
                    return [4 /*yield*/, inquirer_1.default.prompt(askIfInstallGenerator)];
                case 2:
                    answer = _b.sent();
                    if (!answer.ifInstall) return [3 /*break*/, 4];
                    packageManager = (ctx.config || {}).packageManager;
                    if (!packageManager) {
                        ctx.logger.error('cannot find \'packageManager\' from config');
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, (0, npm_1.install)(packageManager, ctx.root, 'install', generator, false)];
                case 3:
                    _b.sent();
                    ctx.logger.info('install success');
                    return [2 /*return*/, run(ctx, generator)];
                case 4:
                    options = generators.map(function (item) { return item.desc; });
                    if (!generators.length) return [3 /*break*/, 6];
                    return [4 /*yield*/, inquirer_1.default.prompt([
                            {
                                type: 'list',
                                name: 'desc',
                                message: '您想要创建哪种类型的工程?',
                                choices: options,
                            },
                        ])];
                case 5:
                    answer_1 = _b.sent();
                    _a = (generators.find(function (item) { return item.desc === answer_1.desc; }) || {}).name, name_1 = _a === void 0 ? '' : _a;
                    ctx.logger.debug('generator name:', name_1);
                    return [2 /*return*/, run(ctx, name_1)];
                case 6:
                    ctx.logger.warn('You have not installed a template yet, '
                        + ' please use install command. Guide: https://github.com/Tencent/feflow');
                    return [2 /*return*/];
            }
        });
    }); });
});
var loadGenerator = function (root, rootPkg) { return new Promise(function (resolve, reject) {
    fs_1.default.readFile(rootPkg, 'utf8', function (err, data) {
        if (err) {
            reject(err);
        }
        else {
            var json = JSON.parse(data);
            var deps = json.dependencies || json.devDependencies || {};
            var generators = Object.keys(deps)
                .filter(function (name) {
                if (!/^generator-|^@[^/]+\/generator-/.test(name)) {
                    return false;
                }
                var generatorPath = path_1.default.join(root, 'node_modules', name);
                return fs_1.default.existsSync(generatorPath);
            })
                .map(function (name) {
                var generatorPkgPath = path_1.default.join(root, 'node_modules', name, 'package.json');
                var generatorPkgData = fs_1.default.readFileSync(generatorPkgPath, 'utf8');
                var generatorPkgJson = JSON.parse(generatorPkgData);
                var desc = generatorPkgJson.description;
                return { name: name, desc: desc };
            });
            resolve(generators);
        }
    });
}); };
var run = function (ctx, name) { return __awaiter(void 0, void 0, void 0, function () {
    var root, yeomanEnv, generatorEntry, error_1;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                root = ctx.root;
                yeomanEnv = yeoman_environment_1.default.createEnv();
                generatorEntry = path_1.default.join(root, 'node_modules', name, 'app/index.js');
                if (!fs_1.default.existsSync(generatorEntry)) {
                    generatorEntry = path_1.default.join(root, 'node_modules', name, 'generators', 'app/index.js');
                }
                if (!fs_1.default.existsSync(generatorEntry)) {
                    return [2 /*return*/, ctx.logger.error('Cannot find generator entry:', generatorEntry)];
                }
                yeomanEnv.register(require.resolve(generatorEntry), name);
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, 4, 5]);
                return [4 /*yield*/, yeomanEnv.run(name, ctx)];
            case 2:
                _b.sent();
                ctx.logger.debug('create project success!');
                return [3 /*break*/, 5];
            case 3:
                error_1 = _b.sent();
                ctx.logger.error(error_1);
                return [3 /*break*/, 5];
            case 4:
                (_a = ctx.reporter) === null || _a === void 0 ? void 0 : _a.reportInitResult();
                return [7 /*endfinally*/];
            case 5: return [2 /*return*/];
        }
    });
}); };
//# sourceMappingURL=init.js.map