"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPluginsList = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var apply_plugins_1 = __importDefault(require("./apply-plugins"));
var getPluginsList = function (ctx) {
    var root = ctx.root, rootPkg = ctx.rootPkg;
    var pluginList = [];
    var err = null;
    var json = {};
    try {
        var data = fs_1.default.readFileSync(rootPkg, 'utf-8');
        json = JSON.parse(data);
    }
    catch (error) {
        err = error;
    }
    if (!json.dependencies) {
        return [err, pluginList];
    }
    var deps = json.dependencies || json.devDependencies || {};
    pluginList = Object.keys(deps).filter(function (name) {
        if (!/^feflow-plugin-|^@[^/]+\/feflow-plugin-/.test(name)) {
            return false;
        }
        var pluginPath = path_1.default.join(root, 'node_modules', name);
        return fs_1.default.existsSync(pluginPath);
    });
    return [err, pluginList];
};
exports.getPluginsList = getPluginsList;
function loadPlugins(ctx) {
    return new Promise(function (resolve, reject) {
        var _a = __read((0, exports.getPluginsList)(ctx), 2), err = _a[0], plugins = _a[1];
        if (err) {
            return reject(err);
        }
        (0, apply_plugins_1.default)(plugins)(ctx);
        resolve();
    });
}
exports.default = loadPlugins;
//# sourceMappingURL=load-plugins.js.map