"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.execPlugin = exports.loadPlugin = void 0;
var path_1 = __importDefault(require("path"));
var binp_1 = __importDefault(require("../universal-pkg/binp"));
var command_picker_1 = require("../command-picker");
var plugin_1 = require("../universal-pkg/schema/plugin");
var yaml_1 = require("../../shared/yaml");
var constant_1 = require("../../shared/constant");
var args_1 = require("../../shared/args");
var toolRegex = /^feflow-(?:devkit|plugin)-(.*)/i;
var excludeAgrs = [constant_1.DISABLE_ARG, constant_1.SILENT_ARG];
function loadPlugin(ctx, pkg, version) {
    var pluginPath = path_1.default.join(ctx.root, constant_1.UNIVERSAL_MODULES, "".concat(pkg, "@").concat(version));
    var pluginConfigPath = path_1.default.join(pluginPath, constant_1.UNIVERSAL_PLUGIN_CONFIG);
    var config = (0, yaml_1.parseYaml)(pluginConfigPath) || {};
    return new plugin_1.Plugin(ctx, pluginPath, config);
}
exports.loadPlugin = loadPlugin;
function register(ctx, pkg, version, global) {
    var _this = this;
    if (global === void 0) { global = false; }
    var commander = ctx.commander;
    var pluginCommand = (toolRegex.exec(pkg) || [])[1] || pkg;
    if (!pluginCommand) {
        ctx.logger.debug("invalid universal plugin name: ".concat(pluginCommand));
        return;
    }
    if (global) {
        // load plugin.yml delay
        commander.register(pluginCommand, function () { return loadPlugin(ctx, pkg, version).desc || "".concat(pkg, " universal plugin description"); }, function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, execPlugin(ctx, pkg, version)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); }, [
            function () {
                var plugin = loadPlugin(ctx, pkg, version);
                return plugin.usage
                    ? {
                        type: 'usage',
                        content: plugin.usage,
                    }
                    : {
                        type: 'path',
                        content: plugin.path,
                    };
            },
        ], pkg);
    }
    else {
        commander.registerInvisible("".concat(pluginCommand, "@").concat(version), function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, execPlugin(ctx, pkg, version)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); }, [], "".concat(pkg, "@").concat(version));
    }
}
function execPlugin(ctx, pkg, version) {
    return __awaiter(this, void 0, void 0, function () {
        var pluginPath, plugin, args;
        var _a;
        return __generator(this, function (_b) {
            pluginPath = path_1.default.join(ctx.root, constant_1.UNIVERSAL_MODULES, "".concat(pkg, "@").concat(version));
            plugin = loadPlugin(ctx, pkg, version);
            // make it find dependencies
            new binp_1.default().register(path_1.default.join(pluginPath, ".".concat(constant_1.FEFLOW_BIN)), true, true);
            // injection plugin path into the env
            process.env[constant_1.FEF_ENV_PLUGIN_PATH] = pluginPath;
            plugin.preRun.run();
            args = process.argv
                .slice(3)
                .filter(function (arg) {
                if (excludeAgrs.includes(arg)) {
                    return false;
                }
                return true;
            })
                .map(function (arg) { return (0, args_1.escape)(arg); });
            (_a = plugin.command).run.apply(_a, __spreadArray([], __read(args), false));
            plugin.postRun.runLess();
            return [2 /*return*/];
        });
    });
}
exports.execPlugin = execPlugin;
function loadUniversalPlugin(ctx) {
    var e_1, _a, e_2, _b, e_3, _c;
    var universalPkg = ctx.universalPkg;
    var pickConfig = new command_picker_1.CacheController(ctx);
    var installed = universalPkg.getInstalled();
    try {
        for (var installed_1 = __values(installed), installed_1_1 = installed_1.next(); !installed_1_1.done; installed_1_1 = installed_1.next()) {
            var _d = __read(installed_1_1.value, 2), pkg = _d[0], version = _d[1];
            pickConfig.registerSubCommand(command_picker_1.CommandType.UNIVERSAL_PLUGIN_TYPE, ctx.commander.store, pkg, version);
            register(ctx, pkg, version, true);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (installed_1_1 && !installed_1_1.done && (_a = installed_1.return)) _a.call(installed_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var dependencies = universalPkg.getAllDependencies();
    try {
        for (var dependencies_1 = __values(dependencies), dependencies_1_1 = dependencies_1.next(); !dependencies_1_1.done; dependencies_1_1 = dependencies_1.next()) {
            var _e = __read(dependencies_1_1.value, 2), pkg = _e[0], versionRelations = _e[1];
            try {
                for (var versionRelations_1 = (e_3 = void 0, __values(versionRelations)), versionRelations_1_1 = versionRelations_1.next(); !versionRelations_1_1.done; versionRelations_1_1 = versionRelations_1.next()) {
                    var _f = __read(versionRelations_1_1.value, 1), version = _f[0];
                    register(ctx, pkg, version, false);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (versionRelations_1_1 && !versionRelations_1_1.done && (_c = versionRelations_1.return)) _c.call(versionRelations_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (dependencies_1_1 && !dependencies_1_1.done && (_b = dependencies_1.return)) _b.call(dependencies_1);
        }
        finally { if (e_2) throw e_2.error; }
    }
    pickConfig.registerSubCommand(command_picker_1.CommandType.UNIVERSAL_PLUGIN_TYPE, ctx.commander.store);
    pickConfig.updateCache(command_picker_1.CommandType.UNIVERSAL_PLUGIN_TYPE);
}
exports.default = loadUniversalPlugin;
//# sourceMappingURL=load-universal-plugin.js.map