"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPm2Process = void 0;
var pm2_1 = __importDefault(require("pm2"));
/**
 * 创建pm2进程
 *
 * @param ctx
 * @param options pm2启动进程参数
 * @param errCallback
 */
function createPm2Process(ctx, options, errCallback) {
    pm2_1.default.connect(function (err) {
        if (err) {
            ctx.logger.error('pm2 connect failed', err);
            return;
        }
        // To release connection to PM2 and make your application auto exit,
        // make sure to disconnect from pm2 with pm2.disconnect()
        pm2_1.default.start(options, errCallback(pm2_1.default));
    });
}
exports.createPm2Process = createPm2Process;
//# sourceMappingURL=pm2.js.map