"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-require-imports */
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var semver_1 = __importDefault(require("semver"));
var osenv_1 = __importDefault(require("osenv"));
var cross_spawn_1 = __importDefault(require("cross-spawn"));
var lodash_1 = __importDefault(require("lodash"));
var lock_file_1 = __importDefault(require("../../shared/lock-file"));
var package_json_1 = __importDefault(require("../../shared/package-json"));
var yaml_1 = require("../../shared/yaml");
var git_1 = require("../../shared/git");
var pkg_1 = require("../universal-pkg/dep/pkg");
var constant_1 = require("../../shared/constant");
var logger_1 = __importDefault(require("../logger"));
var utils_1 = require("./utils");
var install_1 = require("../native/install");
var type_predicates_1 = require("../../shared/type-predicates");
var file_1 = require("../../shared/file");
var package_json_2 = __importDefault(require("../../../package.json"));
var _a = process.env, debug = _a.debug, silent = _a.silent;
var logger = (0, logger_1.default)({
    name: 'feflow-update-beat-process',
    debug: Boolean(debug),
    silent: Boolean(silent),
});
var root = path_1.default.join(osenv_1.default.home(), constant_1.FEFLOW_ROOT);
var configPath = path_1.default.join(root, '.feflowrc.yml');
var universalPkgPath = path_1.default.join(root, constant_1.UNIVERSAL_PKG_JSON);
var dbFile = path_1.default.join(root, constant_1.UPDATE_COLLECTION);
var updateLock = path_1.default.join(root, constant_1.UPDATE_LOCK);
var updateFile = new lock_file_1.default(dbFile, updateLock, logger);
var heartDBFile = path_1.default.join(root, constant_1.HEART_BEAT_COLLECTION);
var beatLock = path_1.default.join(root, constant_1.BEAT_LOCK);
var heartFile = new lock_file_1.default(heartDBFile, beatLock, logger);
// 设置特殊的静默进程名字
process.title = 'feflow-update-beat-process';
var handleException = function (e) {
    logger.error("update_beat_exception: ".concat(e.name, ": ").concat(e.message, " => ").concat(e.stack));
};
process.on('uncaughtException', handleException);
process.on('unhandledRejection', handleException);
var heartBeat = function () {
    heartFile.update(constant_1.BEAT_KEY, String(new Date().getTime()));
};
var queryCliUpdate = function () { return __awaiter(void 0, void 0, void 0, function () {
    var config, latestVersion, updateData, newUpdateData;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                config = (0, yaml_1.parseYaml)(configPath);
                if (!config || !(0, type_predicates_1.isValidConfig)(config)) {
                    return [2 /*return*/];
                }
                if (config.lastUpdateCheck && +new Date() - parseInt(config.lastUpdateCheck, 10) <= 1000 * 3600 * 24) {
                    return [2 /*return*/];
                }
                if (config.autoUpdate !== 'true') {
                    return [2 /*return*/];
                }
                return [4 /*yield*/, (0, utils_1.getLatestVersion)('@feflow/cli', config.packageManager)];
            case 1:
                latestVersion = _a.sent();
                if (!(latestVersion && semver_1.default.gt(latestVersion, package_json_2.default.version))) return [3 /*break*/, 4];
                return [4 /*yield*/, updateFile.read(constant_1.UPDATE_KEY)];
            case 2:
                updateData = (_a.sent());
                if (!((updateData === null || updateData === void 0 ? void 0 : updateData.latest_cli_version) !== latestVersion)) return [3 /*break*/, 4];
                newUpdateData = __assign(__assign({}, updateData), { latest_cli_version: latestVersion });
                return [4 /*yield*/, updateFile.update(constant_1.UPDATE_KEY, newUpdateData)];
            case 3:
                _a.sent();
                _a.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); };
var queryPluginsUpdate = function () { return __awaiter(void 0, void 0, void 0, function () {
    var config;
    return __generator(this, function (_a) {
        config = (0, yaml_1.parseYaml)(configPath);
        if (!config || !(0, type_predicates_1.isValidConfig)(config)) {
            return [2 /*return*/];
        }
        Promise.all((0, utils_1.getInstalledPlugins)().map(function (name) { return __awaiter(void 0, void 0, void 0, function () {
            var pluginPkgJsonPath, pkgJsonStr, pkgJson, localVersion, registryUrl, latestVersion;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        pluginPkgJsonPath = path_1.default.join(root, 'node_modules', name, 'package.json');
                        pkgJsonStr = fs_1.default.readFileSync(pluginPkgJsonPath, {
                            encoding: 'utf8',
                        });
                        pkgJson = JSON.parse(pkgJsonStr);
                        localVersion = pkgJson.version;
                        registryUrl = cross_spawn_1.default
                            .sync(config.packageManager, ['config', 'get', 'registry'], {
                            windowsHide: true,
                        })
                            .stdout.toString()
                            .replace(/\n/, '')
                            .replace(/\/$/, '');
                        return [4 /*yield*/, (0, package_json_1.default)(name, registryUrl).catch(function (err) {
                                logger.debug('Check plugin update error', err);
                            })];
                    case 1:
                        latestVersion = _a.sent();
                        if (latestVersion && semver_1.default.gt(latestVersion, localVersion)) {
                            return [2 /*return*/, {
                                    name: name,
                                    latestVersion: latestVersion,
                                    localVersion: localVersion,
                                }];
                        }
                        logger.debug('All plugins is in latest version');
                        return [2 /*return*/];
                }
            });
        }); })).then(function (plugins) { return __awaiter(void 0, void 0, void 0, function () {
            var pluginsWithName, updateData, newUpdateData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        pluginsWithName = plugins.filter(function (plugin) { return plugin === null || plugin === void 0 ? void 0 : plugin.name; });
                        logger.debug('tnpm plugins update information', pluginsWithName);
                        if (!pluginsWithName.length) return [3 /*break*/, 3];
                        return [4 /*yield*/, updateFile.read(constant_1.UPDATE_KEY)];
                    case 1:
                        updateData = (_a.sent());
                        if (!!lodash_1.default.isEqual(updateData.latest_plugins, pluginsWithName)) return [3 /*break*/, 3];
                        newUpdateData = __assign(__assign({}, updateData), { latest_plugins: pluginsWithName });
                        return [4 /*yield*/, updateFile.update(constant_1.UPDATE_KEY, newUpdateData)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        }); });
        return [2 /*return*/];
    });
}); };
var queryUniversalPluginsUpdate = function () { return __awaiter(void 0, void 0, void 0, function () {
    var config, universalPkg, latestUniversalPlugins, _loop_1, _a, _b, _c, pkg, version, e_1_1, updateData, newUpdateData;
    var e_1, _d;
    return __generator(this, function (_e) {
        switch (_e.label) {
            case 0:
                config = (0, yaml_1.parseYaml)(configPath);
                if (!config || !(0, type_predicates_1.isValidConfig)(config)) {
                    return [2 /*return*/];
                }
                (0, git_1.setServerUrl)(config.serverUrl);
                universalPkg = new pkg_1.UniversalPkg(universalPkgPath);
                latestUniversalPlugins = [];
                _loop_1 = function (pkg, version) {
                    var pkgInfo, versionObj;
                    return __generator(this, function (_f) {
                        switch (_f.label) {
                            case 0: return [4 /*yield*/, (0, install_1.getPkgInfo)({ root: root, config: config, logger: logger }, "".concat(pkg, "@").concat(version)).catch(function (e) { return __awaiter(void 0, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        logger.error("update_error => pkg: ".concat(pkg, "@").concat(version, " => error: ").concat(e));
                                        return [2 /*return*/];
                                    });
                                }); })];
                            case 1:
                                pkgInfo = _f.sent();
                                if (!pkgInfo) {
                                    return [2 /*return*/, "continue"];
                                }
                                return [4 /*yield*/, (0, utils_1.getUniversalPluginVersion)(pkgInfo, universalPkg)];
                            case 2:
                                versionObj = _f.sent();
                                if (versionObj.latestVersion) {
                                    latestUniversalPlugins.push(versionObj);
                                }
                                return [2 /*return*/];
                        }
                    });
                };
                _e.label = 1;
            case 1:
                _e.trys.push([1, 6, 7, 8]);
                _a = __values(universalPkg.getInstalled()), _b = _a.next();
                _e.label = 2;
            case 2:
                if (!!_b.done) return [3 /*break*/, 5];
                _c = __read(_b.value, 2), pkg = _c[0], version = _c[1];
                return [5 /*yield**/, _loop_1(pkg, version)];
            case 3:
                _e.sent();
                _e.label = 4;
            case 4:
                _b = _a.next();
                return [3 /*break*/, 2];
            case 5: return [3 /*break*/, 8];
            case 6:
                e_1_1 = _e.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 8];
            case 7:
                try {
                    if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
                return [7 /*endfinally*/];
            case 8:
                logger.debug('universal plugins update information', latestUniversalPlugins);
                if (!latestUniversalPlugins.length) return [3 /*break*/, 11];
                return [4 /*yield*/, updateFile.read(constant_1.UPDATE_KEY)];
            case 9:
                updateData = (_e.sent());
                if (!!lodash_1.default.isEqual(updateData.latest_universal_plugins, latestUniversalPlugins)) return [3 /*break*/, 11];
                newUpdateData = __assign(__assign({}, updateData), { latest_universal_plugins: latestUniversalPlugins });
                return [4 /*yield*/, updateFile.update(constant_1.UPDATE_KEY, newUpdateData)];
            case 10:
                _e.sent();
                _e.label = 11;
            case 11: return [2 /*return*/];
        }
    });
}); };
// 记录心跳进程的pid
var heartBeatPidPath = path_1.default.join(constant_1.FEFLOW_HOME, constant_1.HEART_BEAT_PID);
(0, file_1.fileExit)(heartBeatPidPath);
(0, file_1.writeFileSync)(heartBeatPidPath, "".concat(process.pid));
// startBeat
setInterval(heartBeat, constant_1.BEAT_GAP);
// queryCliUpdate
setInterval(function () {
    queryCliUpdate().catch(handleException);
}, constant_1.CHECK_UPDATE_GAP);
// queryPluginsUpdate
setInterval(function () {
    queryPluginsUpdate().catch(handleException);
}, constant_1.CHECK_UPDATE_GAP);
// queryUniversalPluginsUpdate
setInterval(function () {
    queryUniversalPluginsUpdate().catch(handleException);
}, constant_1.CHECK_UPDATE_GAP);
//# sourceMappingURL=update-beat.js.map