"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var osenv_1 = __importDefault(require("osenv"));
var semver_1 = __importDefault(require("semver"));
var logger_1 = __importDefault(require("../logger"));
var pkg_1 = require("../universal-pkg/dep/pkg");
var load_universal_plugin_1 = require("../plugin/load-universal-plugin");
var upgrade_1 = require("../native/upgrade");
var install_1 = require("../native/install");
var lock_file_1 = __importDefault(require("../../shared/lock-file"));
var npm_1 = require("../../shared/npm");
var constant_1 = require("../../shared/constant");
var git_1 = require("../../shared/git");
var yaml_1 = require("../../shared/yaml");
var package_json_1 = __importDefault(require("../../../package.json"));
var utils_1 = require("./utils");
var type_predicates_1 = require("../../shared/type-predicates");
// 设置特殊的进程名字
process.title = 'feflow-update-process';
var _a = process.env, cacheValidate = _a.cacheValidate, debug = _a.debug, silent = _a.silent, latestVersion = _a.latestVersion;
var logger = (0, logger_1.default)({
    name: 'feflow-update-process',
    debug: Boolean(debug),
    silent: Boolean(silent),
});
var root = path_1.default.join(osenv_1.default.home(), constant_1.FEFLOW_ROOT);
var rootPkg = path_1.default.join(root, 'package.json');
var configPath = path_1.default.join(root, '.feflowrc.yml');
var universalPkgPath = path_1.default.join(root, constant_1.UNIVERSAL_PKG_JSON);
var universalModules = path_1.default.join(root, constant_1.UNIVERSAL_MODULES);
var config = (0, yaml_1.parseYaml)(configPath);
var bin = path_1.default.join(root, constant_1.FEFLOW_BIN);
var lib = path_1.default.join(root, constant_1.FEFLOW_LIB);
var dbFile = path_1.default.join(root, constant_1.UPDATE_COLLECTION);
var updateLock = path_1.default.join(root, constant_1.UPDATE_LOCK);
var universalPkg = new pkg_1.UniversalPkg(universalPkgPath);
var updateFile = new lock_file_1.default(dbFile, updateLock, logger);
if (!(0, type_predicates_1.isValidConfig)(config)) {
    process.exit();
}
var packageManager = config.packageManager;
// eslint-disable-next-line @typescript-eslint/consistent-type-assertions
var ctx = {
    root: root,
    universalPkg: universalPkg,
    logger: logger,
    universalModules: universalModules,
    bin: bin,
    lib: lib,
    config: config,
};
process.on('uncaughtException', function (e) {
    logger.error("update_exception: ".concat(e.name, ": ").concat(e.message, " => ").concat(e.stack));
});
process.on('unhandledRejection', handleRejection);
var updateData;
update();
function update() {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            updateFile
                .read(constant_1.UPDATE_KEY)
                .then(function (data) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    updateData = data && typeof data === 'object' ? data : {};
                    return [2 /*return*/, Promise.all([startUpdateCli(), checkPluginsUpdate(), checkUniversalPluginsUpdate()]).catch(function (error) {
                            handleRejection(error);
                        })];
                });
            }); })
                .then(function () {
                updateData.update_lock = undefined;
                updateFile.update(constant_1.UPDATE_KEY, updateData);
            })
                .catch(function (reason) {
                updateData.update_lock = undefined;
                updateFile.update(constant_1.UPDATE_KEY, updateData);
                logger.debug(reason);
                handleRejection(reason);
            });
            return [2 /*return*/];
        });
    });
}
function handleRejection(reason) {
    logger.error("update_rejection: ".concat(reason));
}
function startUpdateCli() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!latestVersion) {
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, (0, upgrade_1.updateCli)(packageManager)];
                case 1:
                    _a.sent();
                    updateData.cli_update_msg = {
                        version: package_json_1.default.version,
                        latestVersion: latestVersion,
                    };
                    updateData.latest_cli_version = '';
                    return [2 /*return*/];
            }
        });
    });
}
function startPluginsUpdate(plugins) {
    return __awaiter(this, void 0, void 0, function () {
        var needUpdatePlugins;
        return __generator(this, function (_a) {
            (0, utils_1.updatePluginsVersion)(rootPkg, plugins);
            needUpdatePlugins = [];
            plugins.forEach(function (plugin) {
                needUpdatePlugins.push(plugin.name);
            });
            return [2 /*return*/, (0, npm_1.install)(packageManager, root, packageManager === 'yarn' ? 'add' : 'install', needUpdatePlugins, false).then(function () {
                    updateData.plugins_update_msg = plugins;
                    updateData.latest_plugins = undefined;
                    logger.info('Plugin update success');
                })];
        });
    });
}
function checkPluginsUpdate() {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    (function () { return __awaiter(_this, void 0, void 0, function () {
                        var updatePkg, installedPlugins, pluginsToUpdate_1, checkUpdatePromises, e_1;
                        var _this = this;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 8, , 9]);
                                    if (!Boolean(cacheValidate)) return [3 /*break*/, 3];
                                    updatePkg = updateData.latest_plugins;
                                    if (!(updatePkg === null || updatePkg === void 0 ? void 0 : updatePkg.length)) return [3 /*break*/, 2];
                                    return [4 /*yield*/, startPluginsUpdate(updatePkg)];
                                case 1:
                                    _a.sent();
                                    _a.label = 2;
                                case 2:
                                    resolve();
                                    return [3 /*break*/, 7];
                                case 3:
                                    installedPlugins = (0, utils_1.getInstalledPlugins)();
                                    pluginsToUpdate_1 = [];
                                    checkUpdatePromises = installedPlugins.map(function (pluginName) { return __awaiter(_this, void 0, void 0, function () {
                                        var pluginPath, content, pkgInfo, localVersion, latestVersion;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0:
                                                    pluginPath = path_1.default.join(root, 'node_modules', pluginName, 'package.json');
                                                    content = fs_1.default.readFileSync(pluginPath, {
                                                        encoding: 'utf8',
                                                    });
                                                    pkgInfo = JSON.parse(content);
                                                    localVersion = pkgInfo.version;
                                                    return [4 /*yield*/, (0, utils_1.getLatestVersion)(pluginName, packageManager)];
                                                case 1:
                                                    latestVersion = _a.sent();
                                                    if (latestVersion && semver_1.default.gt(latestVersion, localVersion)) {
                                                        pluginsToUpdate_1.push({
                                                            name: pluginName,
                                                            latestVersion: latestVersion,
                                                        });
                                                    }
                                                    logger.debug('All plugins is in latest version');
                                                    return [2 /*return*/];
                                            }
                                        });
                                    }); });
                                    // 实时拉取最新更新
                                    return [4 /*yield*/, Promise.all(checkUpdatePromises)];
                                case 4:
                                    // 实时拉取最新更新
                                    _a.sent();
                                    if (!pluginsToUpdate_1.length) return [3 /*break*/, 6];
                                    return [4 /*yield*/, startPluginsUpdate(pluginsToUpdate_1)];
                                case 5:
                                    _a.sent();
                                    _a.label = 6;
                                case 6:
                                    resolve();
                                    _a.label = 7;
                                case 7: return [3 /*break*/, 9];
                                case 8:
                                    e_1 = _a.sent();
                                    logger.error(e_1);
                                    reject(e_1);
                                    return [3 /*break*/, 9];
                                case 9: return [2 /*return*/];
                            }
                        });
                    }); })();
                })];
        });
    });
}
function checkUniversalPluginsUpdate() {
    return __awaiter(this, void 0, void 0, function () {
        var updatePkg, serverUrl, latestUniversalPlugins, _loop_1, _a, _b, _c, pkg, version, e_2_1, updateTasks, updateTasks_1, updateTasks_1_1, updateTask, e_3_1;
        var e_2, _d, e_3, _e;
        var _this = this;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    updatePkg = [];
                    serverUrl = config.serverUrl;
                    if (!serverUrl) {
                        return [2 /*return*/];
                    }
                    (0, git_1.setServerUrl)(serverUrl);
                    latestUniversalPlugins = updateData.latest_universal_plugins;
                    if (!(String(cacheValidate) === 'true' && latestUniversalPlugins)) return [3 /*break*/, 1];
                    // 用缓存数据
                    updatePkg = latestUniversalPlugins;
                    return [3 /*break*/, 9];
                case 1:
                    _loop_1 = function (pkg, version) {
                        var pkgInfo, versionObj;
                        return __generator(this, function (_g) {
                            switch (_g.label) {
                                case 0: return [4 /*yield*/, (0, install_1.getPkgInfo)(ctx, "".concat(pkg, "@").concat(version)).catch(function (e) {
                                        logger.error("update_error => pkg: ".concat(pkg, "@").concat(version, " => error: ").concat(e));
                                    })];
                                case 1:
                                    pkgInfo = _g.sent();
                                    if (!pkgInfo) {
                                        return [2 /*return*/, "continue"];
                                    }
                                    return [4 /*yield*/, (0, utils_1.getUniversalPluginVersion)(pkgInfo, universalPkg)];
                                case 2:
                                    versionObj = _g.sent();
                                    if (versionObj.latestVersion) {
                                        updatePkg.push(versionObj);
                                    }
                                    return [2 /*return*/];
                            }
                        });
                    };
                    _f.label = 2;
                case 2:
                    _f.trys.push([2, 7, 8, 9]);
                    _a = __values(universalPkg.getInstalled()), _b = _a.next();
                    _f.label = 3;
                case 3:
                    if (!!_b.done) return [3 /*break*/, 6];
                    _c = __read(_b.value, 2), pkg = _c[0], version = _c[1];
                    return [5 /*yield**/, _loop_1(pkg, version)];
                case 4:
                    _f.sent();
                    _f.label = 5;
                case 5:
                    _b = _a.next();
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 9];
                case 7:
                    e_2_1 = _f.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 9];
                case 8:
                    try {
                        if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 9:
                    if (!updatePkg.length) return [3 /*break*/, 19];
                    updateTasks = updatePkg.map(function (item) { return __awaiter(_this, void 0, void 0, function () {
                        var name, installVersion, plugin;
                        return __generator(this, function (_a) {
                            name = item.name, installVersion = item.installVersion;
                            plugin = (0, load_universal_plugin_1.loadPlugin)(ctx, name, installVersion);
                            return [2 /*return*/, (0, utils_1.promisify)(install_1.updateUniversalPlugin, ctx, name, installVersion, plugin)];
                        });
                    }); });
                    _f.label = 10;
                case 10:
                    _f.trys.push([10, 16, 17, 18]);
                    updateTasks_1 = __values(updateTasks), updateTasks_1_1 = updateTasks_1.next();
                    _f.label = 11;
                case 11:
                    if (!!updateTasks_1_1.done) return [3 /*break*/, 15];
                    updateTask = updateTasks_1_1.value;
                    return [4 /*yield*/, updateTask];
                case 12: return [4 /*yield*/, (_f.sent())()];
                case 13:
                    _f.sent();
                    _f.label = 14;
                case 14:
                    updateTasks_1_1 = updateTasks_1.next();
                    return [3 /*break*/, 11];
                case 15: return [3 /*break*/, 18];
                case 16:
                    e_3_1 = _f.sent();
                    e_3 = { error: e_3_1 };
                    return [3 /*break*/, 18];
                case 17:
                    try {
                        if (updateTasks_1_1 && !updateTasks_1_1.done && (_e = updateTasks_1.return)) _e.call(updateTasks_1);
                    }
                    finally { if (e_3) throw e_3.error; }
                    return [7 /*endfinally*/];
                case 18:
                    updateData.universal_plugins_update_msg = updatePkg;
                    updateData.latest_universal_plugins = undefined;
                    _f.label = 19;
                case 19: return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=update.js.map