"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.promisify = exports.getUniversalPluginVersion = exports.updatePluginsVersion = exports.getLatestVersion = exports.getNpmRegistryUrl = exports.getInstalledPlugins = void 0;
/* eslint-disable @typescript-eslint/no-require-imports */
// 更新依赖
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var osenv_1 = __importDefault(require("osenv"));
var cross_spawn_1 = __importDefault(require("cross-spawn"));
var package_json_1 = __importDefault(require("../../shared/package-json"));
var constant_1 = require("../../shared/constant");
var git_1 = require("../universal-pkg/repository/git");
var logger_1 = __importDefault(require("../logger"));
var version_1 = __importDefault(require("../universal-pkg/dep/version"));
var _a = process.env, debug = _a.debug, silent = _a.silent;
var root = path_1.default.join(osenv_1.default.home(), constant_1.FEFLOW_ROOT);
var rootPkg = path_1.default.join(root, 'package.json');
var universalModulesPath = path_1.default.join(root, constant_1.UNIVERSAL_MODULES);
var logger = (0, logger_1.default)({
    debug: Boolean(debug),
    silent: Boolean(silent),
});
var getInstalledPlugins = function () {
    var plugins = [];
    var exist = fs_1.default.existsSync(rootPkg);
    var pluginDir = path_1.default.join(root, 'node_modules');
    if (!exist) {
        plugins = [];
    }
    else {
        var content = fs_1.default.readFileSync(rootPkg, {
            encoding: 'utf8',
        });
        var json = void 0;
        try {
            json = JSON.parse(content);
            var deps = json.dependencies || json.devDependencies || {};
            plugins = Object.keys(deps);
        }
        catch (ex) {
            plugins = [];
        }
    }
    return plugins.filter(function (name) {
        if (!/^feflow-plugin-|^@[^/]+\/feflow-plugin-|generator-|^@[^/]+\/generator-/.test(name)) {
            return false;
        }
        var pathFn = path_1.default.join(pluginDir, name);
        return fs_1.default.existsSync(pathFn);
    });
};
exports.getInstalledPlugins = getInstalledPlugins;
var getNpmRegistryUrl = function (packageManager) { return cross_spawn_1.default
    .sync(packageManager, ['config', 'get', 'registry'], { windowsHide: true })
    .stdout.toString()
    .replace(/\n/, '')
    .replace(/\/$/, ''); };
exports.getNpmRegistryUrl = getNpmRegistryUrl;
var getLatestVersion = function (name, packageManager) { return __awaiter(void 0, void 0, void 0, function () {
    var registryUrl;
    return __generator(this, function (_a) {
        registryUrl = (0, exports.getNpmRegistryUrl)(packageManager);
        return [2 /*return*/, (0, package_json_1.default)(name, registryUrl).catch(function () {
                logger.warn("Network error, can't reach ".concat(registryUrl, ", CLI give up version check."));
            })];
    });
}); };
exports.getLatestVersion = getLatestVersion;
var updatePluginsVersion = function (packagePath, plugins) {
    var obj = require(packagePath);
    plugins.forEach(function (plugin) {
        obj.dependencies[plugin.name] = plugin.latestVersion;
    });
    fs_1.default.writeFileSync(packagePath, JSON.stringify(obj, null, 4));
};
exports.updatePluginsVersion = updatePluginsVersion;
var getUniversalPluginVersion = function (pkgInfo, universalPkg) { return new Promise(function (resolve) {
    (function () { return __awaiter(void 0, void 0, void 0, function () {
        var repoPath, currentVersion;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    repoPath = path_1.default.join(universalModulesPath, "".concat(pkgInfo.repoName, "@").concat(pkgInfo.installVersion));
                    if (!(pkgInfo.installVersion === constant_1.LATEST_VERSION)) return [3 /*break*/, 2];
                    if (!universalPkg.isInstalled(pkgInfo.repoName, constant_1.LATEST_VERSION)) return [3 /*break*/, 2];
                    return [4 /*yield*/, (0, git_1.getCurrentTag)(repoPath)];
                case 1:
                    currentVersion = (_a.sent()) || '';
                    logger.debug("repoPath => ".concat(repoPath, "; currentVersion => ").concat(currentVersion, "; checkoutTag=> ").concat(pkgInfo.checkoutTag));
                    if (version_1.default.gt(pkgInfo.checkoutTag, currentVersion)) {
                        resolve({
                            name: pkgInfo.repoName,
                            localVersion: currentVersion,
                            latestVersion: pkgInfo.checkoutTag,
                            repoPath: repoPath,
                            installVersion: pkgInfo.installVersion,
                        });
                    }
                    _a.label = 2;
                case 2:
                    resolve({
                        name: pkgInfo.repoName,
                        localVersion: '',
                        latestVersion: '',
                        repoPath: repoPath,
                        installVersion: pkgInfo.installVersion,
                    });
                    return [2 /*return*/];
            }
        });
    }); })();
}); };
exports.getUniversalPluginVersion = getUniversalPluginVersion;
var promisify = function (asyncFun) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return function () { return new Promise(function (resolve) {
        (function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, asyncFun.apply(void 0, __spreadArray([], __read(args), false))];
                    case 1:
                        _a.sent();
                        resolve();
                        return [2 /*return*/];
                }
            });
        }); })();
    }); };
};
exports.promisify = promisify;
//# sourceMappingURL=utils.js.map