import { PkgRelation } from './relation';
export declare class UniversalPkg {
    private pkgFile;
    private version;
    private installed;
    private dependencies;
    constructor(pkgFile: string);
    getInstalled(): Map<string, string>;
    getAllDependencies(): Map<string, Map<string, PkgRelation>>;
    getDepended(pkg: string, version: string): Map<string, string> | undefined;
    getDependencies(pkg: string, version: string): Map<string, string> | undefined;
    isInstalled(pkg: string, version?: string, includeDep?: boolean): boolean;
    install(pkg: string, version: string): void;
    isDependedOnOnOther(pkg: string, version: string): boolean;
    depend(pkg: string, version: string, dependPkg: string, dependPkgVersion: string): void;
    removeInvalidDependencies(): [string, string][];
    removeDepend(pkg: string, version: string, dependPkg: string, dependPkgVersion: string): number;
    uninstall(pkg: string, version: string, isDep?: boolean): void;
    removeDepended(pkg: string, version: string, dependedPkg: string, dependedVersion: string): void;
    getPkgRelation(pkg: string, version: string): PkgRelation | undefined;
    saveChange(): void;
    private isValid;
    private toDependencies;
    private dependedOn;
    private toObject;
}
//# sourceMappingURL=pkg.d.ts.map