"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InstallAttribute = exports.Install = void 0;
var Install = /** @class */ (function () {
    function Install(pkg, iVersion, cVersion, attributes) {
        this.pkg = pkg;
        this.installVersion = iVersion;
        this.checkoutVersion = cVersion;
        this.attributes = attributes;
    }
    Install.from = function (obj) {
        var pkg = obj === null || obj === void 0 ? void 0 : obj.pkg;
        var installVersion = obj === null || obj === void 0 ? void 0 : obj.installVersion;
        var checkoutVersion = obj === null || obj === void 0 ? void 0 : obj.checkoutVersion;
        var attributes = InstallAttribute.from(obj === null || obj === void 0 ? void 0 : obj.attributes);
        return new Install(pkg, installVersion, checkoutVersion, attributes);
    };
    Install.query = function (pkg, iversion) {
        return { pkg: pkg, installVersion: iversion };
    };
    return Install;
}());
exports.Install = Install;
var InstallAttribute = /** @class */ (function () {
    function InstallAttribute(obj) {
        if (obj === null || obj === void 0 ? void 0 : obj.createTime) {
            this.createTime = obj === null || obj === void 0 ? void 0 : obj.createTime;
        }
        else {
            this.createTime = Date.now();
        }
        if (obj === null || obj === void 0 ? void 0 : obj.upgradeTime) {
            this.upgradeTime = obj === null || obj === void 0 ? void 0 : obj.upgradeTime;
        }
    }
    InstallAttribute.from = function (obj) {
        var attribute = new InstallAttribute();
        attribute.upgradeTime = obj === null || obj === void 0 ? void 0 : obj.upgradeTime;
        attribute.createTime = obj === null || obj === void 0 ? void 0 : obj.createTime;
        return attribute;
    };
    return InstallAttribute;
}());
exports.InstallAttribute = InstallAttribute;
//# sourceMappingURL=install.js.map