"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Plugin = void 0;
var command_1 = require("./command");
var dependencies_1 = require("./dependencies");
var base_1 = require("./base");
var Plugin = /** @class */ (function () {
    function Plugin(ctx, pluginPath, config) {
        this.autoUpdate = true;
        // 是否属于语言运行时，语言运行时不需要经过feflow代理执行
        this.langRuntime = false;
        if (!base_1.platform) {
            throw new Error("current operating system [".concat(base_1.platform, "] is not supported"));
        }
        this.ctx = ctx;
        this.path = pluginPath;
        this.name = config === null || config === void 0 ? void 0 : config.name;
        this.desc = config === null || config === void 0 ? void 0 : config.desc;
        this.dep = new dependencies_1.Dependencies(config === null || config === void 0 ? void 0 : config.dep);
        this.command = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config.command);
        this.autoUpdate = (config === null || config === void 0 ? void 0 : config['auto-update']) || false;
        this.test = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config.test);
        this.preInstall = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config['pre-install']);
        this.postInstall = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config['post-install']);
        this.preRun = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config['pre-run']);
        this.postRun = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config['post-run']);
        this.preUpgrade = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config['pre-upgrade']);
        this.postUpgrade = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config['post-upgrade']);
        this.preUninstall = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config['pre-uninstall']);
        this.postUninstall = new command_1.Command(this.ctx, this.path, config === null || config === void 0 ? void 0 : config['post-uninstall']);
        this.usage = config === null || config === void 0 ? void 0 : config.usage;
        this.langRuntime = (config === null || config === void 0 ? void 0 : config['lang-runtime']) || false;
    }
    Plugin.prototype.check = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.dep.check()];
                    case 1:
                        _a.sent();
                        this.command.check();
                        return [2 /*return*/];
                }
            });
        });
    };
    return Plugin;
}());
exports.Plugin = Plugin;
//# sourceMappingURL=plugin.js.map