"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FEFLOW_UPDATE_BEAT_PROCESS = exports.DISABLE_ARG = exports.SILENT_ARG = exports.UPDATE_LOCK = exports.UPDATE_KEY = exports.BEAT_LOCK = exports.BEAT_KEY = exports.LOG_FILE = exports.FEFLOW_PLUGIN_PREFIX = exports.FEFLOW_PLUGIN_GIT_PREFIX = exports.FEFLOW_PLUGIN_LOCAL_PREFIX = exports.INVALID_VERSION = exports.CHECK_UPDATE_GAP = exports.LOG_REPORT_BEAT_GAP = exports.BEAT_GAP = exports.UPDATE_COLLECTION = exports.HEART_BEAT_COLLECTION_LOG = exports.HEART_BEAT_PID = exports.HEART_BEAT_COLLECTION = exports.CACHE_FILE = exports.UNIVERSAL_README_CONFIG = exports.NPM_PLUGIN_INFO_JSON = exports.UPGRADE_INTERVAL = exports.UNIVERSAL_PLUGIN_INSTALL_COLLECTION = exports.UNIVERSAL_PLUGIN_CONFIG = exports.UNIVERSAL_PKG_JSON = exports.UNIVERSAL_MODULES = exports.EVENT_DONE = exports.EVENT_COMMAND_BEGIN = exports.HOOK_TYPE_ON_COMMAND_REGISTERED = exports.HOOK_TYPE_AFTER = exports.HOOK_TYPE_BEFORE = exports.DEVKIT_CONFIG = exports.PROJECT_CONFIG = exports.FEF_ENV_PLUGIN_PATH = exports.LATEST_VERSION = exports.FEFLOW_HOME = exports.FEFLOW_LIB = exports.FEFLOW_BIN = exports.FEFLOW_ROOT = void 0;
var path_1 = __importDefault(require("path"));
var osenv_1 = __importDefault(require("osenv"));
exports.FEFLOW_ROOT = '.fef';
exports.FEFLOW_BIN = 'bin';
exports.FEFLOW_LIB = 'lib';
exports.FEFLOW_HOME = path_1.default.join(osenv_1.default.home(), exports.FEFLOW_ROOT);
exports.LATEST_VERSION = 'latest';
exports.FEF_ENV_PLUGIN_PATH = 'FEF_PLUGIN_PATH';
exports.PROJECT_CONFIG = [
    '.feflowrc.js',
    '.feflowrc.yaml',
    '.feflowrc.yml',
    '.feflowrc.json',
    '.feflowrc',
    'package.json',
];
exports.DEVKIT_CONFIG = ['devkit.js', 'devkit.yaml', 'devkit.yml', 'devkit.json', 'devkitrc', 'package.json'];
/**
 * Namespace for collection of "before" hooks
 */
exports.HOOK_TYPE_BEFORE = 'before';
/**
 * Namespace for collection of "after" hooks
 */
exports.HOOK_TYPE_AFTER = 'after';
exports.HOOK_TYPE_ON_COMMAND_REGISTERED = 'on_command_registered';
/**
 * Emitted when command execution begins
 */
exports.EVENT_COMMAND_BEGIN = 'command begin';
/**
 * Emitted when totally finished
 */
exports.EVENT_DONE = 'done';
exports.UNIVERSAL_MODULES = 'universal_modules';
exports.UNIVERSAL_PKG_JSON = 'universal-package.json';
exports.UNIVERSAL_PLUGIN_CONFIG = 'plugin.yml';
exports.UNIVERSAL_PLUGIN_INSTALL_COLLECTION = 'install.db';
exports.UPGRADE_INTERVAL = 1000 * 60 * 60;
exports.NPM_PLUGIN_INFO_JSON = 'npm-plugin-info.json';
exports.UNIVERSAL_README_CONFIG = 'README.md';
exports.CACHE_FILE = '.feflowCache.yml';
exports.HEART_BEAT_COLLECTION = 'heart-beat.json';
exports.HEART_BEAT_PID = 'heart-beat.pid';
exports.HEART_BEAT_COLLECTION_LOG = 'heart_beat-log.db';
exports.UPDATE_COLLECTION = 'update.json';
exports.BEAT_GAP = 5000;
// 日志上报间隔
exports.LOG_REPORT_BEAT_GAP = 5000;
exports.CHECK_UPDATE_GAP = 1000 * 60 * 5;
exports.INVALID_VERSION = 'v0.0.0';
exports.FEFLOW_PLUGIN_LOCAL_PREFIX = 'feflow-plugin-local-';
exports.FEFLOW_PLUGIN_GIT_PREFIX = 'feflow-plugin-git-';
exports.FEFLOW_PLUGIN_PREFIX = 'feflow-plugin-';
exports.LOG_FILE = 'logger.log';
exports.BEAT_KEY = 'beat_time';
exports.BEAT_LOCK = 'heart-beat.lock';
exports.UPDATE_KEY = 'update_data';
exports.UPDATE_LOCK = 'update.lock';
exports.SILENT_ARG = '--slient';
exports.DISABLE_ARG = '--disable-check';
// 心跳进程名字
exports.FEFLOW_UPDATE_BEAT_PROCESS = 'feflow-update-beat-process';
//# sourceMappingURL=constant.js.map