"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFileExist = exports.copyDir = exports.writeFileAsync = exports.unlinkAsync = exports.readFileAsync = exports.readdirAsync = exports.mkdirAsync = exports.copyFileAsync = exports.statAsync = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var util_1 = __importDefault(require("util"));
exports.statAsync = util_1.default.promisify(fs_1.default.stat);
exports.copyFileAsync = util_1.default.promisify(fs_1.default.copyFile);
exports.mkdirAsync = util_1.default.promisify(fs_1.default.mkdir);
exports.readdirAsync = util_1.default.promisify(fs_1.default.readdir);
exports.readFileAsync = util_1.default.promisify(fs_1.default.readFile);
exports.unlinkAsync = util_1.default.promisify(fs_1.default.unlink);
exports.writeFileAsync = util_1.default.promisify(fs_1.default.writeFile);
function copyDir(srcPath, tarPath) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, srcStats, tarStats, files;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, Promise.all([
                        (0, exports.statAsync)(srcPath).catch(function () { return null; }),
                        (0, exports.statAsync)(tarPath).catch(function () { return null; }),
                    ])];
                case 1:
                    _a = __read.apply(void 0, [_b.sent(), 2]), srcStats = _a[0], tarStats = _a[1];
                    if (!srcStats) {
                        throw new Error("the source path [".concat(srcPath, "] does not exist"));
                    }
                    if (!srcStats.isDirectory()) {
                        throw new Error("the source path [".concat(srcPath, "] is not a folder"));
                    }
                    if (!!tarStats) return [3 /*break*/, 3];
                    return [4 /*yield*/, (0, exports.mkdirAsync)(tarPath, { recursive: true })];
                case 2:
                    _b.sent();
                    _b.label = 3;
                case 3: return [4 /*yield*/, (0, exports.readdirAsync)(srcPath)];
                case 4:
                    files = _b.sent();
                    return [2 /*return*/, copyFiles(srcPath, tarPath, files)];
            }
        });
    });
}
exports.copyDir = copyDir;
function copyFiles(srcPath, tarPath, files) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2 /*return*/, Promise.all(files.map(function (filename) { return __awaiter(_this, void 0, void 0, function () {
                    var fileDir, stats, isFile, destPath, tarFileDir;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                fileDir = path_1.default.join(srcPath, filename);
                                return [4 /*yield*/, (0, exports.statAsync)(fileDir)];
                            case 1:
                                stats = _a.sent();
                                isFile = stats.isFile();
                                if (!isFile) return [3 /*break*/, 3];
                                destPath = path_1.default.join(tarPath, filename);
                                return [4 /*yield*/, (0, exports.copyFileAsync)(fileDir, destPath)];
                            case 2:
                                _a.sent();
                                return [3 /*break*/, 6];
                            case 3:
                                tarFileDir = path_1.default.join(tarPath, filename);
                                return [4 /*yield*/, (0, exports.mkdirAsync)(tarFileDir)];
                            case 4:
                                _a.sent();
                                return [4 /*yield*/, copyDir(fileDir, tarFileDir)];
                            case 5:
                                _a.sent();
                                _a.label = 6;
                            case 6: return [2 /*return*/];
                        }
                    });
                }); }))];
        });
    });
}
function isFileExist(filePath) {
    return fs_1.default.existsSync(filePath);
}
exports.isFileExist = isFileExist;
//# sourceMappingURL=fs.js.map