"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.download = exports.clearGitCertByPath = exports.clearGitCert = exports.transformUrl = exports.setServerUrl = void 0;
var cross_spawn_1 = __importDefault(require("cross-spawn"));
var request_promise_1 = __importDefault(require("request-promise"));
var url_1 = require("./url");
var gitAccount;
var serverUrl;
function setServerUrl(url) {
    serverUrl = url;
}
exports.setServerUrl = setServerUrl;
function getHostname(url) {
    if (/https?/.test(url)) {
        var _a = __read(url.match(/^http(s)?:\/\/(.*?)\//) || [], 3), _b = _a[2], match = _b === void 0 ? '' : _b;
        return match.split('@').pop() || '';
    }
    var _c = __read(url.match(/@(.*):/) || [], 2), _d = _c[1], hostname = _d === void 0 ? '' : _d;
    return hostname;
}
function prepareAccount() {
    return __awaiter(this, void 0, void 0, function () {
        var url, options;
        return __generator(this, function (_a) {
            if (gitAccount) {
                return [2 /*return*/];
            }
            url = (0, url_1.getURL)(serverUrl, 'apply/getlist?name=0');
            if (!url) {
                return [2 /*return*/];
            }
            options = {
                url: url,
                method: 'GET',
            };
            return [2 /*return*/, (0, request_promise_1.default)(options)
                    .then(function (response) {
                    var data = JSON.parse(response);
                    if (data.account) {
                        gitAccount = data.account;
                    }
                })
                    .catch(function () { })];
        });
    });
}
function transformUrl(url, account) {
    return __awaiter(this, void 0, void 0, function () {
        var hostname, transformedUrl, username, password;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!account) return [3 /*break*/, 1];
                    gitAccount = account;
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, prepareAccount()];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    hostname = getHostname(url);
                    if (/https?/.test(url)) {
                        transformedUrl = url;
                    }
                    else {
                        transformedUrl = url.replace("git@".concat(hostname, ":"), "http://".concat(hostname, "/"));
                    }
                    if (gitAccount) {
                        username = gitAccount.username, password = gitAccount.password;
                        return [2 /*return*/, transformedUrl.replace(/https?:\/\/(.*?(:.*?)?@)?/, "http://".concat(username, ":").concat(password, "@"))];
                    }
                    return [2 /*return*/, transformedUrl];
            }
        });
    });
}
exports.transformUrl = transformUrl;
function clearGitCert(url) {
    return __awaiter(this, void 0, void 0, function () {
        var username, finalUrl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    username = gitAccount.username;
                    if (!username) {
                        return [2 /*return*/];
                    }
                    finalUrl = '';
                    if (!!/https?:\/\/(.*?(:.*?)?@)/.test(url)) return [3 /*break*/, 2];
                    return [4 /*yield*/, transformUrl(url)];
                case 1:
                    finalUrl = _a.sent();
                    _a.label = 2;
                case 2: return [2 /*return*/, new Promise(function (resolve, reject) {
                        var _a, _b;
                        var child = (0, cross_spawn_1.default)('git', ['credential', 'reject'], {
                            windowsHide: true,
                            timeout: 60 * 1000,
                        });
                        (_a = child.stdin) === null || _a === void 0 ? void 0 : _a.write("url=".concat(finalUrl));
                        (_b = child.stdin) === null || _b === void 0 ? void 0 : _b.end();
                        child.on('close', function (code) {
                            resolve(code);
                        });
                        child.on('error', function (err) {
                            reject(err);
                        });
                    })];
            }
        });
    });
}
exports.clearGitCert = clearGitCert;
function clearGitCertByPath(repoPath) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var ret, url;
        return __generator(this, function (_b) {
            ret = cross_spawn_1.default.sync('git', ['config', '--get', 'remote.origin.url'], {
                windowsHide: true,
                cwd: repoPath,
            });
            url = (_a = ret === null || ret === void 0 ? void 0 : ret.stdout) === null || _a === void 0 ? void 0 : _a.toString().trim();
            return [2 /*return*/, clearGitCert(url)];
        });
    });
}
exports.clearGitCertByPath = clearGitCertByPath;
function download(url, tag, filepath) {
    return __awaiter(this, void 0, void 0, function () {
        var cloneUrl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, transformUrl(url)];
                case 1:
                    cloneUrl = _a.sent();
                    console.log('clone from', url);
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            var _a, _b;
                            var child = (0, cross_spawn_1.default)('git', ['clone', '-b', tag, '--progress', '--depth', '1', cloneUrl, filepath], {
                                stdio: 'pipe',
                                windowsHide: true,
                            });
                            var doneFlag = false;
                            (_a = child.stderr) === null || _a === void 0 ? void 0 : _a.on('data', function (d) {
                                var _a, _b;
                                if (doneFlag) {
                                    return;
                                }
                                if (((_a = d === null || d === void 0 ? void 0 : d.toString()) === null || _a === void 0 ? void 0 : _a.startsWith('Note:')) || ((_b = d === null || d === void 0 ? void 0 : d.toString()) === null || _b === void 0 ? void 0 : _b.startsWith('注意'))) {
                                    doneFlag = true;
                                    return;
                                }
                                process.stderr.write(d);
                            });
                            (_b = child.stdout) === null || _b === void 0 ? void 0 : _b.on('data', function (d) {
                                if (doneFlag) {
                                    return;
                                }
                                process.stdout.write(d);
                            });
                            child.on('close', function (code) {
                                if (code === 0) {
                                    resolve(0);
                                }
                                else {
                                    reject(code);
                                }
                            });
                            child.on('error', function (err) {
                                reject(err);
                            });
                        })
                            // eslint-disable-next-line @typescript-eslint/no-misused-promises
                            .finally(function () { return clearGitCert(cloneUrl); })];
            }
        });
    });
}
exports.download = download;
//# sourceMappingURL=git.js.map