"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var semver_1 = __importDefault(require("semver"));
function packageJson(name, registry) {
    var names = (name || '').split('@');
    var version = !names[0] ? names[2] : names[1];
    var isValidVersion = semver_1.default.valid(version) || version === 'latest';
    var url = "".concat(registry, "/").concat(isValidVersion ? "@".concat(names[1], "/").concat(names[2]) : name);
    return axios_1.default
        .get(url, {
        proxy: false,
    })
        .then(function (response) {
        var data = (response || { 'dist-tags': {} }).data;
        if (!isValidVersion) {
            var version_1 = data['dist-tags'].latest;
            return version_1 || '';
        }
        // 指定包的版本情况
        return data.version || '';
    })
        .catch(function (err) { return err; });
}
exports.default = packageJson;
//# sourceMappingURL=package-json.js.map