"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkProcessExistByPid = exports.isProcessExist = void 0;
// 查询进程的代码参考https://github.com/neekey/ps
var child_process_1 = require("child_process");
var os_1 = __importDefault(require("os"));
var ps_node_1 = __importDefault(require("ps-node"));
/**
 * End of line.
 * Basically, the EOL should be:
 * - windows: \r\n
 * - *nix: \n
 * try to get every possibilities covered.
 */
var EOL = /(\r\n)|(\n\r)|\n|\r/;
var SystemEOL = os_1.default.EOL;
var IS_WIN = process.platform === 'win32';
function lookUpAllProcess() {
    return new Promise(function (resolve, reject) {
        if (IS_WIN) {
            var CMD = (0, child_process_1.spawn)('cmd');
            var stdout_1 = '';
            var stderr_1 = '';
            CMD.stdout.on('data', function (data) {
                stdout_1 += data.toString();
            });
            CMD.stderr.on('data', function (data) {
                stderr_1 += data.toString();
            });
            CMD.on('exit', function () {
                var beginRow;
                var stdoutArr = stdout_1.split(EOL);
                // Find the line index for the titles
                stdoutArr.forEach(function (out, index) {
                    if (out && typeof beginRow === 'undefined' && out.indexOf('CommandLine') === 0) {
                        beginRow = index;
                    }
                });
                // get rid of the start (copyright) and the end (current pwd)
                stdoutArr.splice(stdout_1.length - 1, 1);
                stdoutArr.splice(0, beginRow);
                if (stderr_1) {
                    return reject(stderr_1);
                }
                return resolve(stdoutArr.join(SystemEOL));
            });
            CMD.stdin.write('wmic process get ProcessId,ParentProcessId,CommandLine \n');
            CMD.stdin.end();
        }
        else {
            var child = (0, child_process_1.spawn)('ps', ['aux']);
            var stdout_2 = '';
            var stderr_2 = '';
            child.stdout.on('data', function (data) {
                stdout_2 += data.toString();
            });
            child.stderr.on('data', function (data) {
                stderr_2 += data.toString();
            });
            child.on('exit', function () {
                if (stderr_2) {
                    return reject(stderr_2);
                }
                return resolve(stdout_2);
            });
        }
    });
}
;
// 判断某个进程是否存在
function isProcessExist(psName) {
    return __awaiter(this, void 0, void 0, function () {
        var psInfo, pattern, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, lookUpAllProcess()];
                case 1:
                    psInfo = _a.sent();
                    pattern = new RegExp("".concat(psName));
                    return [2 /*return*/, pattern.test(psInfo)];
                case 2:
                    e_1 = _a.sent();
                    console.error(e_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.isProcessExist = isProcessExist;
;
// 根据进程id判断某个进程是否存在
function checkProcessExistByPid(pid) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    if (!pid)
                        return resolve(false);
                    ps_node_1.default.lookup({ pid: pid }, function (err, psList) {
                        if (err)
                            return reject(err);
                        if (Array.isArray(psList) && psList[0]) {
                            resolve(true);
                        }
                        else {
                            resolve(false);
                        }
                    });
                })];
        });
    });
}
exports.checkProcessExistByPid = checkProcessExistByPid;
//# sourceMappingURL=process.js.map