"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeDump = exports.parseYaml = void 0;
var fs_1 = __importDefault(require("fs"));
var js_yaml_1 = __importDefault(require("js-yaml"));
function parseYaml(path) {
    var config;
    if (fs_1.default.existsSync(path)) {
        config = js_yaml_1.default.safeLoad(fs_1.default.readFileSync(path, 'utf8'));
    }
    return config;
}
exports.parseYaml = parseYaml;
function safeDump(obj, path) {
    var doc = js_yaml_1.default.safeDump(obj, {
        styles: {
            '!!null': 'canonical',
        },
        sortKeys: true,
        skipInvalid: true,
    });
    return fs_1.default.writeFileSync(path, doc, 'utf-8');
}
exports.safeDump = safeDump;
//# sourceMappingURL=yaml.js.map